VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4455
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4575
   LinkTopic       =   "Form1"
   ScaleHeight     =   4455
   ScaleWidth      =   4575
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_Cx As Single
Private m_Cy As Single
Private m_Radius As Single

Private m_Drawing As Boolean
Private m_X1 As Single
Private m_Y1 As Single
Private m_X2 As Single
Private m_Y2 As Single

Private Function FindLineCircleIntersections(ByVal cx As Single, ByVal cy As Single, ByVal radius As Single, ByVal x1 As Single, ByVal y1 As Single, ByVal x2 As Single, ByVal y2 As Single, ByRef ix1 As Single, ByRef iy1 As Single, ByRef ix2 As Single, ByRef iy2 As Single) As Integer
Dim dx As Single
Dim dy As Single
Dim A As Single
Dim B As Single
Dim C As Single
Dim det As Single
Dim t As Single

    dx = x2 - x1
    dy = y2 - y1

    A = dx * dx + dy * dy
    B = 2 * (dx * (x1 - cx) + dy * (y1 - cy))
    C = (x1 - cx) * (x1 - cx) + (y1 - cy) * (y1 - cy) - radius * radius

    det = B * B - 4 * A * C
    If (A <= 0.0000001) Or (det < 0) Then
        ' No real solutions.
        FindLineCircleIntersections = 0
    ElseIf det = 0 Then
        ' One solution.
        FindLineCircleIntersections = 1
        t = -B / (2 * A)
        ix1 = x1 + t * dx
        iy1 = y1 + t * dy
    Else
        ' Two solutions.
        FindLineCircleIntersections = 2
        t = (-B + Sqr(det)) / (2 * A)
        ix1 = x1 + t * dx
        iy1 = y1 + t * dy
        t = (-B - Sqr(det)) / (2 * A)
        ix2 = x1 + t * dx
        iy2 = y1 + t * dy
    End If
End Function

Private Sub Form_Load()
    Me.ScaleMode = vbPixels
    Me.AutoRedraw = True
End Sub


Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    m_Drawing = True

    Me.Cls
    Me.Circle (m_Cx, m_Cy), m_Radius, vbBlue

    m_X1 = X
    m_Y1 = Y
    m_X2 = X
    m_Y2 = Y
    Me.DrawMode = vbInvert
    Me.Line (m_X1, m_Y1)-(m_X2, m_Y2)
End Sub


Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Not m_Drawing Then Exit Sub

    Me.Line (m_X1, m_Y1)-(m_X2, m_Y2)
    m_X2 = X
    m_Y2 = Y
    Me.Line (m_X1, m_Y1)-(m_X2, m_Y2)
End Sub


Private Sub Form_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim ix1 As Single
Dim iy1 As Single
Dim ix2 As Single
Dim iy2 As Single

    m_Drawing = False
    Me.DrawMode = vbCopyPen

    Me.Line (m_X1, m_Y1)-(m_X2, m_Y2), &HFF00FF

    ' Find the intersection.
    Select Case FindLineCircleIntersections(m_Cx, m_Cy, m_Radius, m_X1, m_Y1, m_X2, m_Y2, ix1, iy1, ix2, iy2)
        Case 0
        Case 1
            Me.Line (ix1 - 2, iy1 - 2)-Step(4, 4), vbRed, BF
        Case 2
            Me.Line (ix1 - 2, iy1 - 2)-Step(4, 4), vbRed, BF
            Me.Line (ix2 - 2, iy2 - 2)-Step(4, 4), vbRed, BF
    End Select
End Sub

Private Sub Form_Resize()
    m_Cx = ScaleWidth / 2
    m_Cy = ScaleHeight / 2
    If m_Cx > m_Cy Then
        m_Radius = m_Cy * 0.9
    Else
        m_Radius = m_Cx * 0.9
    End If

    Me.Cls
    Me.Circle (m_Cx, m_Cy), m_Radius, vbBlue
End Sub


